<?php
if ( ! class_exists( 'BravePop_Analytics' ) ) {
   
   class BravePop_Analytics {

      static function fetchPopupStats( $popupID ) {
         if(!$popupID){ return; }
         global $wpdb; $viewTable = $wpdb->prefix . 'bravepopup_stats';
         $popupID = absint( $popupID );
         $sql   = 'SELECT * FROM ' . $viewTable . " WHERE `popup` = '$popupID' DESC";
         return $wpdb->get_results( $sql );
      }

      static function fetchAllStats(  ) {
         global $wpdb; $viewTable = $wpdb->prefix . 'bravepopup_stats';
         $sql   = 'SELECT * FROM ' . $viewTable . "";
         return $wpdb->get_results( $sql );
      }

      static function fetchPopupGoals( $popupID,  $startDate, $endDate, $offset=3 ) {
         if(!$popupID || !$startDate || !$endDate){ return; }
         global $wpdb; $goalTable = $wpdb->prefix . 'bravepopup_goal_stats';
         $popupID = absint( $popupID ); $pagination ='';
         if($offset){
            $pagination = "OFFSET $offset ROWS FETCH NEXT 3 ROWS ONLY";
         }
         $sql   = 'SELECT * FROM ' . $goalTable . " WHERE (`popup` = '$popupID' AND `goal_time` BETWEEN '$startDate' AND '$endDate') ORDER BY goal_time";
         return $wpdb->get_results( $sql );
      }

      static function fetchAllPopupGoals( $startDate, $endDate ) {
         if(!$startDate || !$endDate){ return; }
         global $wpdb; $goalTable = $wpdb->prefix . 'bravepopup_goal_stats';
         //$startDate = '2020-08-24';  $endDate = '2020-08-25 23:59:59';
         $sql   = 'SELECT * FROM ' . $goalTable . "  WHERE `goal_time` BETWEEN '$startDate' and '$endDate'";
         return $wpdb->get_results( $sql );
      }

      static function insertGoal( $data ) {
         if(!$data){ return; }
         global $wpdb; $goalTable = $wpdb->prefix . 'bravepopup_goal_stats';
         $wpdb->insert( $goalTable, $data );
      }

      static function updateGoal( $data, $where ) {
         if(!$data || !$where){ return; }
         global $wpdb; $goalTable = $wpdb->prefix . 'bravepopup_goal_stats';
         $wpdb->update( $goalTable, $data, $where );
      }

      static function deleteGoal( $goalID ) {
         if(!$goalID){ return; }
         global $wpdb; $goalTable = $wpdb->prefix . 'bravepopup_goal_stats';
         return $wpdb->delete( $goalTable, array( 'id' => $goalID ) );
      }

      static function insertStat( $data ) {
         if(!$data){ return; }
         global $wpdb; $viewTable = $wpdb->prefix . 'bravepopup_stats';
         $wpdb->insert( $viewTable, $data );
      }

      static function updatePopupStat( $popupID, $type, $date, $bothTypes=false ) {
         if(!$date || !$popupID){ return; }
         $startTime = microtime(true);
         global $wpdb; $viewTable = $wpdb->prefix . 'bravepopup_stats';
         $popupID = absint($popupID);
         $sql   = 'SELECT * FROM ' . $viewTable . " WHERE `popup` = '$popupID'";
         $popupViewRow = $wpdb->get_results( $sql );
         // error_log($type.' '.json_encode($popupViewRow));
         if(isset($popupViewRow[0])){
            $foundRow = $popupViewRow[0];
            $where = array('id'=> absint($foundRow->id));
            $popupViews = json_decode($foundRow->stats);

            if(!isset($popupViews->$date)){ $popupViews->$date = new stdClass();  }
            if($bothTypes){
               $currentViewCount = isset($popupViews->$date->views) ? intval($popupViews->$date->views) : 0;
               $currentGoalCount = isset($popupViews->$date->goals) ? intval($popupViews->$date->goals) : 0;
               $popupViews->$date->views = $currentViewCount + 1; 
               $popupViews->$date->goals = $currentGoalCount + 1;
            }else{
               $currentCount = isset($popupViews->$date->$type) ? intval($popupViews->$date->$type) : 0;
               $popupViews->$date->$type = $currentCount + 1;
            }

            $foundRow->stats = json_encode($popupViews);
            $wpdb->update( $viewTable, array('stats'=> $foundRow->stats), $where );

         }else{
            $newdata = array('stats'=>'', 'popup'=> $popupID);
            $viewData = array();
            $viewData[$date] = array('views'=> 1, 'goals'=> ($bothTypes ? 1 : 0) );
            $newdata['stats'] = json_encode($viewData);
            //error_log('ROW NOT FOUND. ADDING: '.json_encode($viewData). ' Type: '. $type);
            $wpdb->insert( $viewTable, $newdata );
         }
         $endTime = microtime(true);
         $diff = $endTime - $startTime;
         //error_log("script execution time: $diff");
      }

      static function removePopupStat( $popupID ) {
         if(!$popupID){ return; }
         global $wpdb; 
         $goalTable = $wpdb->prefix . 'bravepopup_goal_stats';
         $viewTable = $wpdb->prefix . 'bravepopup_stats';
         $popupID = absint($popupID);
         update_post_meta( $popupID, 'popup_views', 0 );
         update_post_meta( $popupID, 'popup_conversion', 0 );
         $wpdb->delete( $goalTable, array( 'popup' => $popupID ) );
         $wpdb->delete( $viewTable, array( 'popup' => $popupID ) );
         //error_log('ALL Stats Removed!!!');
         return true;
      }

   }

}
?>